/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of XS.xs. Do not edit this file, edit XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "XS.xs"
/* -*- Mode: C -*- */

#define PERL_NO_GET_CONTEXT 1

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <string.h>

#include "ppport.h"

const double pi = 3.14159265358979;

const double deg2rad = 0.0174532925199433;
const double rad2deg = 57.2957795130823;

const double k0 = 0.9996;
const double inv_k0 = 1.00040016006403;

#define MAX_ELLIPSOIDS 100

struct ellipsoid {
    int defined;
    double radius;
    double inv_radius;
    double eccentricity_2;
    double eccentricity_4;
    double eccentricity_6;
    double eccentricity_prime_2;
};

static struct ellipsoid ellipsoids[MAX_ELLIPSOIDS];

static char latitude_letter[] = "CDEFGHJKLMNPQRSTUVWXX";

static HV *ellipsoid_hv;

int
ellipsoid_index(pTHX_ SV *name) {
    /* Perl_warn(aTHX_ "looking for ellipsoid %_\n", name); */
    if (SvIOK(name)) {
        return SvIV(name);
    }
    {
        HE *he = hv_fetch_ent(ellipsoid_hv, name, FALSE, 0);
        if (he) {
            SV *sv = HeVAL(he);
            if (sv && SvIOK(sv)) {
                /* Perl_warn(aTHX_ "found at %i\n", SvIV(sv)); */
                return SvIV(sv);
            }
        }
    }
    {
        int n, index;
        dSP;
        ENTER;
        SAVETMPS;
        PUSHMARK(SP);
        XPUSHs(name);
        PUTBACK;
        n = call_pv("Geo::Coordinates::UTM::XS::_ellipsoid_index", G_SCALAR);
        SPAGAIN;
        if (n != 1)
            Perl_croak(aTHX_ "internal error: _ellipsoid_index failed");
        index = POPi;
        PUTBACK;
        FREETMPS;
        LEAVE;
        return index;
    }
}

void
_zonesv_to_number_letter(pTHX_ SV *zone, int *zone_number, char *zone_letter) {
    int i;
    STRLEN zone_len;
    char *zone_pv = SvPV(zone, zone_len);
    int zone_ok = 1;

    for (i=0; i<zone_len; i++) {
        if (zone_pv[i] >= '0' && zone_pv[i] <= '9') continue;
        if (i+1 == zone_len) {
            *zone_letter = zone_pv[i];
            if(strchr(latitude_letter, *zone_letter)) continue;
        }
        zone_ok = 0;
        break;
    }
    if (zone_ok) {
        (*zone_number) = atoi(zone_pv);
        if ((*zone_number) < 1 || (*zone_number) > 60)
            zone_ok = 0;
    }
    if(!zone_ok)
        Perl_croak(aTHX_ "UTM zone (%s) invalid.", zone_pv);
}

void
_latlon_to_utm(pTHX_ SV *ename, double latitude_deg, double longitude_deg,
               int *zone, char *zone_letter, double *easting, double *northing) {
    dSP;
    int index;
    double radius;
    double eccentricity_2, eccentricity_4, eccentricity_6, eccentricity_prime_2;
    double longitude_origin_deg, longitude_origin;
    double latitude, delta_longitude, delta_longitude_deg;
    double sin_latitude, cos_latitude, tan_latitude, sin_latitude_2, cos_latitude_2;
    double sin_2_latitude, cos_2_latitude, sin_4_latitude, cos_4_latitude, sin_6_latitude;
    double N, tan_latitude_2, tan_latitude_4, tan_latitude_6, C, A, A_2, A_3, A_4, A_5, A_6, M;
    
    index = ellipsoid_index(aTHX_ ename);
    
    /* Perl_warn(aTHX_ "ename: %_, eindex: %d", ename, index); */
    
    if (index < 1 || index >= MAX_ELLIPSOIDS || !ellipsoids[index].defined) {
        Perl_croak(aTHX_ "invalid ellipsoid index %i", index);
    }
    
    if (longitude_deg < -180.0 || longitude_deg > 180)
        Perl_croak(aTHX_ "Longitude value (%f) invalid.", longitude_deg);
    
    if (longitude_deg == 180)
        longitude_deg = -180;
    
    if (latitude_deg < -80 || latitude_deg > 84.0)
        Perl_croak(aTHX_ "Latitude (%f) out of UTM range", latitude_deg);

    if (!*zone_letter)
        *zone_letter = latitude_letter[(int)(10 + latitude_deg / 8)];
    
    radius = ellipsoids[index].radius;
    eccentricity_2 = ellipsoids[index].eccentricity_2;
    eccentricity_4 = ellipsoids[index].eccentricity_4;
    eccentricity_6 = ellipsoids[index].eccentricity_6;

    eccentricity_prime_2 = ellipsoids[index].eccentricity_prime_2;

    if (!(*zone)) {
        if (latitude_deg >= 56.0 && latitude_deg < 64.0 && longitude_deg >= 3.0 && longitude_deg < 12.0) {
            (*zone) = 32;
        }
        else if (latitude_deg >= 72.0 && latitude_deg < 84.0) {
            if (longitude_deg >= 0.0) {
                if (longitude_deg < 9.0)
                    (*zone) = 31;
                else if (longitude_deg < 21.0)
                    (*zone) = 33;
                else if (longitude_deg < 33.0)
                    (*zone) = 35;
                else if (longitude_deg < 42.0)
                    (*zone) = 37;
                else
                    (*zone) = (longitude_deg + 180)/6 + 1;
            }
            else {
                (*zone) = (longitude_deg + 180)/6 + 1;
            }
        }
        else {
            (*zone) = (longitude_deg + 180)/6 + 1;
        }
    }
    
    latitude = deg2rad * latitude_deg;
    // longitude = deg2rad * longitude_deg;

    longitude_origin_deg = ((*zone) - 1) * 6 - 180 + 3;

    delta_longitude_deg = longitude_deg - longitude_origin_deg;
    if (delta_longitude_deg > 180)
        delta_longitude_deg -= 360;
    if (delta_longitude_deg < -180)
        delta_longitude_deg += 360;
    delta_longitude = deg2rad * delta_longitude_deg;
        
    sin_latitude = sin(latitude);
    cos_latitude = cos(latitude);
    tan_latitude = sin_latitude / cos_latitude;
    
    sin_latitude_2 = sin_latitude * sin_latitude;
    cos_latitude_2 = cos_latitude * cos_latitude;

    sin_2_latitude = 2.0 * sin_latitude * cos_latitude;
    cos_2_latitude = cos_latitude_2 - sin_latitude_2;
    
    sin_4_latitude = 2.0 * sin_2_latitude * cos_2_latitude;
    cos_4_latitude = cos_2_latitude * cos_2_latitude - sin_2_latitude * sin_2_latitude;
    
    sin_6_latitude = sin_2_latitude * cos_4_latitude + sin_4_latitude * cos_2_latitude;
        
    N = radius / sqrt(1 - eccentricity_2 * sin_latitude_2);
    tan_latitude_2 = tan_latitude * tan_latitude;
    C = eccentricity_prime_2 * cos_latitude_2;
    A = cos_latitude * delta_longitude;
    M = radius * ( ( 1 - 0.25 * eccentricity_2 - (3./64.) * eccentricity_4 - (5./256.) * eccentricity_6 ) * latitude
                   - ( (3./8.) * eccentricity_2 + (3./32.) * eccentricity_4 + (45./1024.) * eccentricity_6) * sin_2_latitude
                   + ( ( 15./256.) * eccentricity_4 + (45./1024.) * eccentricity_6) * sin_4_latitude
                   - (35./3072.) * eccentricity_6 * sin_6_latitude);

    A_2 = A * A;
    A_3 = A_2 * A;
    A_4 = A_3 * A;
    A_5 = A_4 * A;
    A_6 = A_5 * A;

    tan_latitude_4 = tan_latitude_2 * tan_latitude_2;
        
    *easting =   500000.0 + k0 * N * (A + (1 - tan_latitude_2 + C) * A_3 * (1./6.) + (5 - 18 * tan_latitude_2 + tan_latitude_4 + 72 * C - 58 * eccentricity_prime_2) * A_5 * (1./120.));

    *northing= k0 * ( M + N * tan_latitude * ( A * A / 2 + (5 - tan_latitude_2 + 9 * C + 4 * C * C) * A_4 * (1./ 24.)
                                             + (61 - 58 * tan_latitude_2 + tan_latitude_4 + 600 * C - 330 * eccentricity_prime_2) * A_6 * (1./720.)));

    if ((*zone_letter) < 'N')
        *northing += 10000000.0;
}
    

#line 229 "XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 373 "XS.c"

XS_EUPXS(XS_Geo__Coordinates__UTM__XS__set_ellipsoid_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__Coordinates__UTM__XS__set_ellipsoid_info)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "index, radius, eccentricity_2");
    {
	int	index = (int)SvIV(ST(0))
;
	double	radius = (double)SvNV(ST(1))
;
	double	eccentricity_2 = (double)SvNV(ST(2))
;
#line 233 "XS.xs"
    {
        if (index < 1 || index >= MAX_ELLIPSOIDS || ellipsoids[index].defined) {
            Perl_croak(aTHX_ "invalid ellipsoid index %i", index);
        }
        ellipsoids[index].radius = radius;
        ellipsoids[index].inv_radius = 1.0/radius;
        ellipsoids[index].eccentricity_2 = eccentricity_2;
        ellipsoids[index].eccentricity_4 = eccentricity_2 * eccentricity_2;
        ellipsoids[index].eccentricity_6 = eccentricity_2 * eccentricity_2 * eccentricity_2;
        ellipsoids[index].eccentricity_prime_2 = eccentricity_2/(1-eccentricity_2);
        ellipsoids[index].defined = 1;
    }
#line 401 "XS.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Geo__Coordinates__UTM__XS__latlon_to_utm); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__Coordinates__UTM__XS__latlon_to_utm)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ename, latitude_deg, longitude_deg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ename = ST(0)
;
	double	latitude_deg = (double)SvNV(ST(1))
;
	double	longitude_deg = (double)SvNV(ST(2))
;
#line 253 "XS.xs"
    int zone = 0;
    char zone_letter = 0;
    double easting, northing;
#line 426 "XS.c"
#line 257 "XS.xs"
    _latlon_to_utm(aTHX_ ename, latitude_deg, longitude_deg,
                   &zone, &zone_letter, &easting, &northing);
    XPUSHs(sv_2mortal(newSVpvf("%d%c", zone, zone_letter)));
    XPUSHs(sv_2mortal(newSVnv(easting)));
    XPUSHs(sv_2mortal(newSVnv(northing)));
    XSRETURN(3);
#line 434 "XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Geo__Coordinates__UTM__XS__latlon_to_utm_force_zone); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__Coordinates__UTM__XS__latlon_to_utm_force_zone)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ename, zone, latitude_deg, longitude_deg");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ename = ST(0)
;
	SV *	zone = ST(1)
;
	double	latitude_deg = (double)SvNV(ST(2))
;
	double	longitude_deg = (double)SvNV(ST(3))
;
#line 272 "XS.xs"
    int zone_number;
    char zone_letter;
    double easting, northing;
#line 462 "XS.c"
#line 276 "XS.xs"
    zone_letter = 0;
    _zonesv_to_number_letter(aTHX_ zone, &zone_number, &zone_letter);
    if (zone_number < 0 || zone_number > 60)
        Perl_croak(aTHX_ "Zone value (%d) invalid.", zone_number);
    _latlon_to_utm(aTHX_ ename, latitude_deg, longitude_deg,
                   &zone_number, &zone_letter, &easting, &northing);
    XPUSHs(sv_2mortal(newSVpvf("%d%c", zone_number, zone_letter)));
    XPUSHs(sv_2mortal(newSVnv(easting)));
    XPUSHs(sv_2mortal(newSVnv(northing)));
    XSRETURN(3);
#line 474 "XS.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Geo__Coordinates__UTM__XS__utm_to_latlon); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Geo__Coordinates__UTM__XS__utm_to_latlon)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "ename, zone, easting, northing");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ename = ST(0)
;
	SV *	zone = ST(1)
;
	double	easting = (double)SvNV(ST(2))
;
	double	northing = (double)SvNV(ST(3))
;
#line 297 "XS.xs"
    {
        int index;
        double radius, inv_radius, eccentricity_2, eccentricity_4, eccentricity_6, eccentricity_prime_2;
        double x, y;
        double longitude_origin_deg;
        double M, mu, e1, e1_2, e1_3, e1_4, phi1, N1, N2, N3, tan_phi1_2, C1, C1_2, R1, D, D_2, D_3, D_4, D_5, D_6;
        double sin_phi1, cos_phi1, inv_cos_phi1, tan_phi1, sin_phi1_2, tan_phi1_4;
        double latitude_deg, longitude_deg;
        int zone_number;
        char zone_letter;
        int i, zone_ok;

        index = ellipsoid_index(aTHX_ ename);

        if (index < 1 || index >= MAX_ELLIPSOIDS || !ellipsoids[index].defined) {
            Perl_croak(aTHX_ "invalid ellipsoid index %i", index);
        }

        radius = ellipsoids[index].radius;
        inv_radius = ellipsoids[index].inv_radius;

        eccentricity_2 = ellipsoids[index].eccentricity_2;
        eccentricity_4 = ellipsoids[index].eccentricity_4;
        eccentricity_6 = ellipsoids[index].eccentricity_6;
        eccentricity_prime_2 = ellipsoids[index].eccentricity_prime_2;

        zone_letter = 'N';
        _zonesv_to_number_letter(aTHX_ zone, &zone_number, &zone_letter);

        x = easting - 500000.0;
        y = northing;
        if (zone_letter < 'N')
            y -= 10000000.0;

        M = inv_k0 * y;
        mu = M / (radius * (1 - eccentricity_2 * (1./4.) - eccentricity_4 * (3./64.) - eccentricity_6 * (5./256.)));
        e1 = -1 + 2 * (1 - sqrt(1 - eccentricity_2)) / eccentricity_2;

        e1_2 = e1 * e1;
        e1_3 = e1_2 * e1;
        e1_4 = e1_3 * e1;

        phi1 = mu + (1.5 * e1 - e1_3 * (27./32.)) * sin(2 * mu) + (e1_2 * (21./16.) - e1_4 * (55./32.)) * sin(4 * mu) + (e1_3 * (151./96.)) * sin(6 * mu);

        sin_phi1 = sin(phi1);
        cos_phi1 = cos(phi1);
        inv_cos_phi1 = 1.0 / cos_phi1;
        tan_phi1 = sin_phi1 * inv_cos_phi1;

        sin_phi1_2 = sin_phi1 * sin_phi1;

        N3 = sqrt(1 - eccentricity_2 * sin_phi1_2);
        N2 = 1.0 / N3;
        N1 = radius * N2;

        tan_phi1_2 = tan_phi1 * tan_phi1;
        tan_phi1_4 = tan_phi1_2 * tan_phi1_2;

        C1 = eccentricity_2 * cos_phi1 * cos_phi1;
        C1_2 = C1 * C1;

        R1 = radius * (1-eccentricity_2) * N2 * N2 * N2;

        D = inv_k0 * inv_radius * N3 * x;
        D_2 = D * D;
        D_3 = D_2 * D;
        D_4 = D_3 * D;
        D_5 = D_4 * D;
        D_6 = D_5 * D;

        latitude_deg = rad2deg * (phi1 - (N1 * tan_phi1 / R1) * (D_2 / 2 - (5 + 3 * tan_phi1_2 + 10 * C1 - 4 * C1_2 - 9 * eccentricity_prime_2) * D_4 * (1./24.)
                                                                  + (61 + 90 * tan_phi1_2 + 298 * C1 + 45 * tan_phi1_4 - 252 * eccentricity_prime_2 - 3 * C1_2) * D_6 * (1./720)));

        longitude_origin_deg = (zone_number - 1) * 6 - 180 + 3;
        longitude_deg = ((D - (1 + 2 * tan_phi1_2 + C1) * D_3 / 6 + (5 - 2 * C1 + 28 * tan_phi1_2 - 3 * C1_2 + 8 * eccentricity_prime_2 + 24 * tan_phi1_4) * D_5 * (1./120.)) * inv_cos_phi1) * rad2deg + longitude_origin_deg;

        if (longitude_deg < -180) longitude_deg += 360.0;
        if (longitude_deg > 180) longitude_deg -= 360.0;

        XPUSHs(sv_2mortal(newSVnv(latitude_deg)));
        XPUSHs(sv_2mortal(newSVnv(longitude_deg)));
    }
    XSRETURN(2);
#line 582 "XS.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Geo__Coordinates__UTM__XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Geo__Coordinates__UTM__XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Geo::Coordinates::UTM::XS::_set_ellipsoid_info", XS_Geo__Coordinates__UTM__XS__set_ellipsoid_info, file, "@");
        (void)newXSproto_portable("Geo::Coordinates::UTM::XS::_latlon_to_utm", XS_Geo__Coordinates__UTM__XS__latlon_to_utm, file, "$$$");
        (void)newXSproto_portable("Geo::Coordinates::UTM::XS::_latlon_to_utm_force_zone", XS_Geo__Coordinates__UTM__XS__latlon_to_utm_force_zone, file, "$$$$");
        (void)newXSproto_portable("Geo::Coordinates::UTM::XS::_utm_to_latlon", XS_Geo__Coordinates__UTM__XS__utm_to_latlon, file, "$$$$");

    /* Initialisation Section */

#line 223 "XS.xs"
memset(ellipsoids, 0, sizeof(ellipsoids));
ellipsoid_hv = GvHV(gv_fetchpv("Geo::Coordinates::UTM::XS::_ellipsoid", TRUE, SVt_PVHV));

#line 627 "XS.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

